//+------------------------------------------------------------------+
//|                                           Iyke's Pivot Point.mq4 |
//|                                   Copyright 2017, Wami ikechukwu |
//|                                          wamiikechukwu@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, Wami ikechukwu"
#property link      "wamiikechukwu@gmail.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
//-----
extern bool UseMonthlyPivotPoint=true; // Use Monthly Pivot Point.
extern bool UseDailyPivotPoint=false; // Use Daily Pivot Point.
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   for(int i=prev_calculated; i<rates_total; i++)
     {

      //-----MONTHLY PIVOTS TIME FRAME
      double MonthlyHigh=NormalizeDouble(iHigh(NULL,PERIOD_MN1,1),5);
      double MonthlyLow=NormalizeDouble(iLow(NULL,PERIOD_MN1,1),5);
      double MonthlyClose=NormalizeDouble(iClose(NULL,PERIOD_MN1,1),5);
      //-----MONTHLY PIVOT CALCULATION
      double PivotPoint=NormalizeDouble((MonthlyHigh+MonthlyLow+MonthlyClose)/3,5);
      double Res1=NormalizeDouble((2*PivotPoint)-MonthlyLow,5);
      double Sup1=NormalizeDouble((2*PivotPoint)-MonthlyHigh,5);
      double Res2=NormalizeDouble(PivotPoint+(MonthlyHigh-MonthlyLow),5);
      double Sup2=NormalizeDouble(PivotPoint-(MonthlyHigh-MonthlyLow),5);
      double Res3=NormalizeDouble(MonthlyHigh+2*(PivotPoint-MonthlyLow),5);
      double Sup3= NormalizeDouble(MonthlyLow-2*(MonthlyHigh-PivotPoint),5);
      //---
      datetime StartingTime=iTime(NULL,PERIOD_MN1,0);
      if(UseMonthlyPivotPoint)
        {
         if(ObjectFind(0,"Pivot Point Monthly")!=0)
           {
            ObjectCreate("Pivot Point Monthly",OBJ_GANNLINE,0,StartingTime,PivotPoint,TimeCurrent(),0);
            ObjectSet("Pivot Point Monthly",OBJPROP_COLOR,clrWheat);
            ObjectSet("Pivot Point Monthly",OBJPROP_STYLE,STYLE_SOLID);
            ObjectSet("Pivot Point Monthly",OBJPROP_WIDTH,2);
            ObjectSet("Pivot Point Monthly",OBJPROP_BACK,true);
            ObjectSet("Pivot Point Monthly",OBJPROP_RAY,true);
            ObjectSet("Pivot Point Monthly",OBJPROP_HIDDEN,true);
            ObjectSet("Pivot Point Monthly",OBJPROP_SELECTED,false);
            ObjectSet("Pivot Point Monthly",OBJPROP_SELECTABLE,false);
            ObjectSetDouble(0,"Pivot Point Monthly",OBJPROP_SCALE,0.01);
           }
         //---
         if(ObjectFind(0,"PP Monthly")!=0)
           {
            ObjectCreate("PP Monthly",OBJ_TEXT,0,StartingTime,PivotPoint);
            ObjectSetText("PP Monthly","   Pivot Point Monthly",10,"Times New Roman",clrWheat);
            ObjectSet("PP Monthly",OBJPROP_HIDDEN,true);
            ObjectSet("PP Monthly",OBJPROP_SELECTED,false);
            ObjectSet("PP Monthly",OBJPROP_SELECTABLE,false);
           }
         //---
         if(ObjectFind(0,"Resistance one Monthly")!=0)
           {
            ObjectCreate("Resistance one Monthly",OBJ_GANNLINE,0,StartingTime,Res1,TimeCurrent(),0);
            ObjectSet("Resistance one Monthly",OBJPROP_COLOR,clrDarkGreen);
            ObjectSet("Resistance one Monthly",OBJPROP_STYLE,STYLE_SOLID);
            ObjectSet("Resistance one Monthly",OBJPROP_WIDTH,2);
            ObjectSet("Resistance one Monthly",OBJPROP_BACK,true);
            ObjectSet("Resistance one Monthly",OBJPROP_RAY,true);
            ObjectSet("Resistance one Monthly",OBJPROP_HIDDEN,true);
            ObjectSet("Resistance one Monthly",OBJPROP_SELECTED,false);
            ObjectSet("Resistance one Monthly",OBJPROP_SELECTABLE,false);
            ObjectSetDouble(0,"Resistance one Monthly",OBJPROP_SCALE,0.01);
           }
         //---
         if(ObjectFind(0,"R1 Monthly")!=0)
           {
            ObjectCreate("R1 Monthly",OBJ_TEXT,0,StartingTime,Res1);
            ObjectSetText("R1 Monthly","   Resistance one Monthly",10,"Times New Roman",clrDarkGreen);
            ObjectSet("R1 Monthly",OBJPROP_HIDDEN,true);
            ObjectSet("R1 Monthly",OBJPROP_SELECTED,false);
            ObjectSet("R1 Monthly",OBJPROP_SELECTABLE,false);
           }
         //---
         if(ObjectFind(0,"Resistance two Monthly")!=0)
           {
            ObjectCreate("Resistance two Monthly",OBJ_GANNLINE,0,StartingTime,Res2,TimeCurrent(),0);
            ObjectSet("Resistance two Monthly",OBJPROP_COLOR,clrDarkGreen);
            ObjectSet("Resistance two Monthly",OBJPROP_STYLE,STYLE_SOLID);
            ObjectSet("Resistance two Monthly",OBJPROP_WIDTH,2);
            ObjectSet("Resistance two Monthly",OBJPROP_BACK,true);
            ObjectSet("Resistance two Monthly",OBJPROP_RAY,true);
            ObjectSet("Resistance two Monthly",OBJPROP_HIDDEN,true);
            ObjectSet("Resistance two Monthly",OBJPROP_SELECTED,false);
            ObjectSet("Resistance two Monthly",OBJPROP_SELECTABLE,false);
            ObjectSetDouble(0,"Resistance two Monthly",OBJPROP_SCALE,0.01);
           }
         //----
         if(ObjectFind(0,"R2 Monthly")!=0)
           {
            ObjectCreate("R2 Monthly",OBJ_TEXT,0,StartingTime,Res2);
            ObjectSetText("R2 Monthly","   Resistance two Monthly",10,"Times New Roman",clrDarkGreen);
            ObjectSet("R2 Monthly",OBJPROP_HIDDEN,true);
            ObjectSet("R2 Monthly",OBJPROP_SELECTED,false);
            ObjectSet("R2 Monthly",OBJPROP_SELECTABLE,false);
           }
         //---
         if(ObjectFind(0,"Resistance three Monthly")!=0)
           {
            ObjectCreate("Resistance three Monthly",OBJ_GANNLINE,0,StartingTime,Res3,TimeCurrent(),0);
            ObjectSet("Resistance three Monthly",OBJPROP_COLOR,clrDarkGreen);
            ObjectSet("Resistance three Monthly",OBJPROP_STYLE,STYLE_SOLID);
            ObjectSet("Resistance three Monthly",OBJPROP_WIDTH,2);
            ObjectSet("Resistance three Monthly",OBJPROP_BACK,true);
            ObjectSet("Resistance three Monthly",OBJPROP_RAY,true);
            ObjectSet("Resistance three Monthly",OBJPROP_HIDDEN,true);
            ObjectSet("Resistance three Monthly",OBJPROP_SELECTED,false);
            ObjectSet("Resistance three Monthly",OBJPROP_SELECTABLE,false);
            ObjectSetDouble(0,"Resistance three Monthly",OBJPROP_SCALE,0.01);
           }
         //---
 if(ObjectFind(0,"R3 Monthly")!=0)
     {
      ObjectCreate("R3 Monthly",OBJ_TEXT,0,StartingTime,Res3);
      ObjectSetText("R3 Monthly","   Resistance three Monthly",10,"Times New Roman",clrDarkGreen);
      ObjectSet("R3 Monthly",OBJPROP_HIDDEN,true);
      ObjectSet("R3 Monthly",OBJPROP_SELECTED,false);
      ObjectSet("R3 Monthly",OBJPROP_SELECTABLE,false);
     }
     //---
     if(ObjectFind(0,"Support one Monthly")!=0)
     {
      ObjectCreate("Support one Monthly",OBJ_GANNLINE,0,StartingTime,Sup1,TimeCurrent(),0);
      ObjectSet("Support one Monthly",OBJPROP_COLOR,clrMaroon);
      ObjectSet("Support one Monthly",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Support one Monthly",OBJPROP_WIDTH,2);
      ObjectSet("Support one Monthly",OBJPROP_BACK,true);
      ObjectSet("Support one Monthly",OBJPROP_RAY,true);
      ObjectSet("Support one Monthly",OBJPROP_HIDDEN,true);
      ObjectSet("Support one Monthly",OBJPROP_SELECTED,false);
      ObjectSet("Support one Monthly",OBJPROP_SELECTABLE,false);
      ObjectSetDouble(0,"Support one Monthly",OBJPROP_SCALE,0.01);
     }
     //---
     if(ObjectFind(0,"S1 Monthly")!=0)
     {
      ObjectCreate("S1 Monthly",OBJ_TEXT,0,StartingTime,Sup1);
      ObjectSetText("S1 Monthly","   Support one Monthly",10,"Times New Roman",clrMaroon);
      ObjectSet("S1 Monthly",OBJPROP_HIDDEN,true);
      ObjectSet("S1 Monthly",OBJPROP_SELECTED,false);
      ObjectSet("S1 Monthly",OBJPROP_SELECTABLE,false);
     }
  
   if(ObjectFind(0,"Support two Monthly")!=0)
     {
      ObjectCreate("Support two Monthly",OBJ_GANNLINE,0,StartingTime,Sup2,TimeCurrent(),0);
      ObjectSet("Support two Monthly",OBJPROP_COLOR,clrMaroon);
      ObjectSet("Support two Monthly",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Support two Monthly",OBJPROP_WIDTH,2);
      ObjectSet("Support two Monthly",OBJPROP_BACK,true);
      ObjectSet("Support two Monthly",OBJPROP_RAY,true);
      ObjectSet("Support two Monthly",OBJPROP_HIDDEN,true);
      ObjectSet("Support two Monthly",OBJPROP_SELECTED,false);
      ObjectSet("Support two Monthly",OBJPROP_SELECTABLE,false);
      ObjectSetDouble(0,"Support two Monthly",OBJPROP_SCALE,0.01);
     }
   //------  
   if(ObjectFind(0,"S2 Monthly")!=0)
     {
      ObjectCreate("S2 Monthly",OBJ_TEXT,0,StartingTime,Sup2);
      ObjectSetText("S2 Monthly","   Support two Monthly",10,"Times New Roman",clrMaroon);
      ObjectSet("S2 Monthly",OBJPROP_HIDDEN,true);
      ObjectSet("S2 Monthly",OBJPROP_SELECTED,false);
      ObjectSet("S2 Monthly",OBJPROP_SELECTABLE,false);
     }
     

   if(ObjectFind(0,"Support three Monthly")!=0)
     {
      ObjectCreate("Support three Monthly",OBJ_GANNLINE,0,StartingTime,Sup3,TimeCurrent(),0);
      ObjectSet("Support three Monthly",OBJPROP_COLOR,clrMaroon);
      ObjectSet("Support three Monthly",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Support three Monthly",OBJPROP_WIDTH,2);
      ObjectSet("Support three Monthly",OBJPROP_BACK,true);
      ObjectSet("Support three Monthly",OBJPROP_RAY,true);
      ObjectSet("Support three Monthly",OBJPROP_HIDDEN,true);
      ObjectSet("Support three Monthly",OBJPROP_SELECTED,false);
      ObjectSet("Support three Monthly",OBJPROP_SELECTABLE,false);
      ObjectSetDouble(0,"Support three Monthly",OBJPROP_SCALE,0.01);
     }
   //---------  
   if(ObjectFind(0,"S3 Monthly")!=0)
     {
      ObjectCreate("S3 Monthly",OBJ_TEXT,0,StartingTime,Sup3);
      ObjectSetText("S3 Monthly","   Support two Monthly",10,"Times New Roman",clrMaroon);
      ObjectSet("S3 Monthly",OBJPROP_HIDDEN,true);
      ObjectSet("S3 Monthly",OBJPROP_SELECTED,false);
      ObjectSet("S3 Monthly",OBJPROP_SELECTABLE,false);
     }
     ChartRedraw(0);
        }
      //---
     }

   return(0);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
